
Redmine - Defect #5138

Don't use Ajax for pagination

2010-03-20 18:54 - Kenn Wilson

Status: Closed Start date: 2010-03-20

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 1.2.0   

Resolution: Fixed Affected version:  

Description

Redmine currently uses Ajax to load pages in the forums. While the pagination links have URLs like boards/1?page=2, clicks are

actually intercepted by JavaScript which loads the next page of results without changing the URL.

While it's true that there's little value to bookmarking individual pages of forums posts, as they change frequently, the real problem is

that it breaks browser behavior when using the back button after reading a particular thread. The browser will reload the URL without

the ?page=N query string, resulting in the first page of posts being displayed, regardless of what page the reader was on initially.

Browser behavior noted in Safari and Firefox on Mac OS X.

Related issues:

Related to Redmine - Defect #7736: Going back to search results after examini... Closed 2011-02-28

Related to Redmine - Defect #1965: Redmine is not Tab Safe Closed 2008-09-29

Has duplicate Redmine - Defect #657: Back button - loses current page after v... Closed 2008-02-13

Has duplicate Redmine - Patch #7594: Proper pagination Closed 2011-02-09

Has duplicate Redmine - Feature #5572: Build search queries in the address bar Closed 2010-05-21

Associated revisions

Revision 5301 - 2011-04-03 16:01 - Jean-Philippe Lang

Makes all pagination-like links use #link_to_content_update (#5138).

Revision 5302 - 2011-04-03 16:06 - Jean-Philippe Lang

Changes pagination links to non-AJAX requests (#5138).

History

#1 - 2010-03-20 18:55 - Kenn Wilson

I've just realized this applies to issue lists as well. Thanks.

#2 - 2010-03-22 12:04 - Henrik Ammer

I say leave the AJAX in but add a history manager of some sorts. Maybe ReallySimpleHistory could be a start?

Then no back-/forwardbuttons will break.

#3 - 2011-01-12 16:01 - Andy Bolstridge

+1 to this - its really annoying to read the redmin.org forum, get to page 20 of forum questions, read one, click back and find you have to click all the

way through to get back to page 20! REALLY annoying.

If there was a 'return to forum list' link, that'd be ok, but there is nothing except the back button. The back button appears to work correctly on the

issues list, so somewhere this was fixed (or un-ajaxed). Either way, it really is broken functionality at present.

#4 - 2011-02-02 11:50 - Anonymous

+1

I'm surprised this is not seen as a major problem (a Rails app that works horribly on a Mac!). I am trying to get this introduced at work instead of Jira

but can't in any honesty recommend it you can't reliably navigate through multipage issues lists.

I notice the same problem occurs on the plugins list - go explore a plugin's details and when you hit the back button you go back to page 1.
http://code.google.com/p/reallysimplehistory/


This is on Safari but I too have seen it on Firefox on Mac.

#5 - 2011-02-08 20:06 - Brian Lindahl

Same problem exists for browsing the issue list. See #3494 and #3494.

This appears to be a major fundamental problem in several areas of Redmine that shows the original developer's lack of experience in some areas of

web development. Paged browsing should be implemented very carefully via Ajax. Either don't use it, or use a strategy such as modifying the URL

with the hash mark ('#') to capture the page number.

See http://www.contentwithstyle.co.uk/content/fixing-the-back-button-and-enabling-bookmarking-for-ajax-apps

#6 - 2011-02-09 18:50 - Brian Lindahl

Er, also related to #1965.

#7 - 2011-02-09 19:14 - Brian Lindahl

related to #657

#8 - 2011-02-09 21:06 - Brian Lindahl

In #7594, I've created a patch to temporarily solve this problem until a real solution exists. It disables Ajax updates and uses direct linking for

pagination.

#9 - 2011-04-12 21:25 - Jean-Philippe Lang

- Subject changed from Don't use Ajax for forum pages to Don't use Ajax for pagination

- Category changed from Forums to UI

- Status changed from New to Closed

- Target version set to 1.2.0

- Resolution set to Fixed

Ajax pagination removed in r5302.

#10 - 2015-04-06 16:31 - Go MAEDA

- Has duplicate Defect #657: Back button - loses current page after viewing an issue - IE only added

#11 - 2015-04-06 16:34 - Go MAEDA

- Has duplicate Patch #7594: Proper pagination added

#12 - 2023-05-08 14:38 - Go MAEDA

- Has duplicate Feature #5572: Build search queries in the address bar added
